/*
 * 
 * 
 * Desenvolvido por Procempa
 */
package sorteionotalegalpoa;

import java.awt.Image;
import java.awt.Toolkit;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import javax.swing.text.MaskFormatter;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Date;
import java.util.stream.Collectors;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.text.NumberFormatter;

public class SorteioNotaLegal extends javax.swing.JFrame {
	private final String versao = "V.1.0"; 

	/**
	 * Creates new form SorteioNotaLegal
	 */
	public SorteioNotaLegal() {
		initComponents();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
	// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
	private void initComponents() {
		java.awt.GridBagConstraints gridBagConstraints;
		try{   
			jPanel1 = new javax.swing.JPanel();
			jPanel2 = new javax.swing.JPanel();
			sorteioNumLabel = new javax.swing.JLabel();
			dataIniSorteioLabel = new javax.swing.JLabel();
			dataFimSorteioLabel = new javax.swing.JLabel();
			totalNotaSorteioLabel = new javax.swing.JLabel();

			DateFormat df = new SimpleDateFormat("dd/mm/yyyy");
			MaskFormatter mfd = new MaskFormatter("##/##/####");

			NumberFormat format = NumberFormat.getInstance();
			NumberFormatter numberFormatter = new NumberFormatter(format);
			numberFormatter.setValueClass(Long.class);
			numberFormatter.setAllowsInvalid(false);
			numberFormatter.setMinimum(1l);

			numTotalNotaParticipante = new javax.swing.JFormattedTextField(numberFormatter);
			dataFimSorteioTfield = new javax.swing.JFormattedTextField(mfd);
			dataIniSorteioTfield = new javax.swing.JFormattedTextField(mfd);
			geraNumBotao = new javax.swing.JButton();
			sorteioNumTfield = new javax.swing.JFormattedTextField(numberFormatter);
			qtdPremiosLabel = new javax.swing.JLabel();
			qtdPremiosTfield = new javax.swing.JFormattedTextField(numberFormatter);
			procempaLabel = new javax.swing.JLabel();
			devLabel = new javax.swing.JLabel();
			jPanel3 = new javax.swing.JPanel();
			premio1Label = new javax.swing.JLabel();
			premio2Label = new javax.swing.JLabel();
			premio3Label = new javax.swing.JLabel();
			premio4Label = new javax.swing.JLabel();
			premio5Label = new javax.swing.JLabel();

			MaskFormatter mf = new MaskFormatter("##.###");
			mf.setPlaceholder("00.000");
			mf.setPlaceholderCharacter('0');

			premio1Tfield = new javax.swing.JFormattedTextField(mf);
			premio2Tfield = new javax.swing.JFormattedTextField(mf);
			premio3Tfield = new javax.swing.JFormattedTextField(mf);
			premio4Tfield = new javax.swing.JFormattedTextField(mf);
			premio5Tfield = new javax.swing.JFormattedTextField(mf);
			dataLoteriaFederalLabel = new javax.swing.JLabel();
			dataLoteriaFederalTfield = new javax.swing.JFormattedTextField(mfd);

			setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
			setTitle("Sorteio Nota Legal Porto Alegre - Versão 1.0");
			URL imageurl = getClass().getClassLoader().getResource("Images/nota_32_2.png");
			Image image = Toolkit.getDefaultToolkit().getImage(imageurl);

			List<Image> icons = new ArrayList<Image>();
			icons.add(image);

			setIconImages(icons);

			setResizable(false);

			setForeground(java.awt.Color.white);
			getContentPane().setLayout(new java.awt.GridBagLayout());

			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 14))); // NOI18N
			jPanel1.setPreferredSize(new java.awt.Dimension(720, 300));
			jPanel1.setRequestFocusEnabled(false);
			jPanel1.setLayout(null);

			jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Informações sobre Sorteio", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 14))); // NOI18N
			jPanel2.setMinimumSize(new java.awt.Dimension(310, 162));
			jPanel2.setName("Informações sobre o Sorteio"); // NOI18N
			jPanel2.setPreferredSize(new java.awt.Dimension(330, 226));
			jPanel2.setLayout(new java.awt.GridBagLayout());

			sorteioNumLabel.setText("Sorteio Número :");
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 1;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
			jPanel2.add(sorteioNumLabel, gridBagConstraints);

			dataIniSorteioLabel.setText("Data Início Periodo:");
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 2;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
			jPanel2.add(dataIniSorteioLabel, gridBagConstraints);

			dataFimSorteioLabel.setText("Data Final Periodo:");
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 3;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
			jPanel2.add(dataFimSorteioLabel, gridBagConstraints);

			totalNotaSorteioLabel.setText("Número de Bilhetes Gerados:");
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 4;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
			jPanel2.add(totalNotaSorteioLabel, gridBagConstraints);

			numTotalNotaParticipante.setMinimumSize(new java.awt.Dimension(100, 27));
			numTotalNotaParticipante.setPreferredSize(new java.awt.Dimension(100, 27));
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 1;
			gridBagConstraints.gridy = 4;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jPanel2.add(numTotalNotaParticipante, gridBagConstraints);

			dataFimSorteioTfield.setMinimumSize(new java.awt.Dimension(100, 27));
			dataFimSorteioTfield.setPreferredSize(new java.awt.Dimension(100, 27));
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 1;
			gridBagConstraints.gridy = 3;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jPanel2.add(dataFimSorteioTfield, gridBagConstraints);

			dataIniSorteioTfield.setMinimumSize(new java.awt.Dimension(100, 27));
			dataIniSorteioTfield.setPreferredSize(new java.awt.Dimension(100, 27));
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 1;
			gridBagConstraints.gridy = 2;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jPanel2.add(dataIniSorteioTfield, gridBagConstraints);

			geraNumBotao.setText("Gerar Números");
			geraNumBotao.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent evt) {
					geraNumBotaoActionPerformed(evt);
				}
			});
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 1;
			gridBagConstraints.gridy = 6;
			jPanel2.add(geraNumBotao, gridBagConstraints);

			sorteioNumTfield.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(new java.text.DecimalFormat("#0"))));
			sorteioNumTfield.setPreferredSize(new java.awt.Dimension(100, 27));
			sorteioNumTfield.setMinimumSize(new java.awt.Dimension(100, 27));
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 1;
			gridBagConstraints.gridy = 1;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jPanel2.add(sorteioNumTfield, gridBagConstraints);

			qtdPremiosLabel.setText("Quantidade de Prêmios:");
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 5;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
			jPanel2.add(qtdPremiosLabel, gridBagConstraints);

			qtdPremiosTfield.setPreferredSize(new java.awt.Dimension(100, 27));
			qtdPremiosTfield.setMinimumSize(new java.awt.Dimension(100, 27));
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 1;
			gridBagConstraints.gridy = 5;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jPanel2.add(qtdPremiosTfield, gridBagConstraints);

			jPanel1.add(jPanel2);
			jPanel2.setBounds(350, 20, 325, 226);

			procempaLabel.setFont(new java.awt.Font("Ubuntu", 3, 15)); // NOI18N
			procempaLabel.setForeground(new java.awt.Color(253, 243, 243));
			procempaLabel.setText("Procempa");
			jPanel1.add(procempaLabel);
			procempaLabel.setBounds(360, 270, 80, 20);

			devLabel.setForeground(new java.awt.Color(254, 247, 247));
			devLabel.setText("desenvolvimento");
			jPanel1.add(devLabel);
			devLabel.setBounds(250, 270, 140, 20);


			jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Informações sobre a Loteria Federal", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 14))); // NOI18N
			jPanel3.setPreferredSize(new java.awt.Dimension(315, 226));
			jPanel3.setLayout(new java.awt.GridBagLayout());

			premio1Label.setText("1º Prêmio:");
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 2;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
			jPanel3.add(premio1Label, gridBagConstraints);

			premio2Label.setText("2º Prêmio:");
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 4;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
			jPanel3.add(premio2Label, gridBagConstraints);

			premio3Label.setText("3º Prêmio:");
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 6;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
			jPanel3.add(premio3Label, gridBagConstraints);

			premio4Label.setText("4º Prêmio:");
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 8;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
			jPanel3.add(premio4Label, gridBagConstraints);

			premio5Label.setText("5º Prêmio:");
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 10;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
			jPanel3.add(premio5Label, gridBagConstraints);

			premio1Tfield.setPreferredSize(new java.awt.Dimension(20, 27));
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 2;
			gridBagConstraints.gridy = 2;
			gridBagConstraints.gridheight = 2;
			gridBagConstraints.ipadx = 90;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jPanel3.add(premio1Tfield, gridBagConstraints);

			premio2Tfield.setPreferredSize(new java.awt.Dimension(20, 27));
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 2;
			gridBagConstraints.gridy = 4;
			gridBagConstraints.gridheight = 2;
			gridBagConstraints.ipadx = 90;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jPanel3.add(premio2Tfield, gridBagConstraints);

			premio3Tfield.setPreferredSize(new java.awt.Dimension(20, 27));
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 2;
			gridBagConstraints.gridy = 6;
			gridBagConstraints.gridheight = 2;
			gridBagConstraints.ipadx = 90;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jPanel3.add(premio3Tfield, gridBagConstraints);

			premio4Tfield.setPreferredSize(new java.awt.Dimension(20, 27));
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 2;
			gridBagConstraints.gridy = 8;
			gridBagConstraints.gridheight = 2;
			gridBagConstraints.ipadx = 90;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jPanel3.add(premio4Tfield, gridBagConstraints);

			premio5Tfield.setPreferredSize(new java.awt.Dimension(20, 27));
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 2;
			gridBagConstraints.gridy = 10;
			gridBagConstraints.gridheight = 2;
			gridBagConstraints.ipadx = 90;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jPanel3.add(premio5Tfield, gridBagConstraints);

			dataLoteriaFederalLabel.setText("Data Sorteio:");
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.gridwidth = java.awt.GridBagConstraints.RELATIVE;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
			jPanel3.add(dataLoteriaFederalLabel, gridBagConstraints);

			dataLoteriaFederalTfield.setToolTipText("");
			dataLoteriaFederalTfield.setPreferredSize(new java.awt.Dimension(20, 27));
			gridBagConstraints = new java.awt.GridBagConstraints();
			gridBagConstraints.gridx = 2;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.gridheight = 2;
			gridBagConstraints.ipadx = 90;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jPanel3.add(dataLoteriaFederalTfield, gridBagConstraints);

			jPanel1.add(jPanel3);
			jPanel3.setBounds(30, 20, 315, 226);

			getContentPane().add(jPanel1, new java.awt.GridBagConstraints());
		}catch(ParseException e){
		}
		pack();
		setLocationRelativeTo(null);
	}// </editor-fold>//GEN-END:initComponents

	private void geraNumBotaoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_geraNumBotaoActionPerformed
		if (validaCamposVazios()){
			realizarSorteio();
		}
	}//GEN-LAST:event_geraNumBotaoActionPerformed

	private void premio1SortTfieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_premio1SortTfieldActionPerformed
		// TODO add your handling code here:
	}//GEN-LAST:event_premio1SortTfieldActionPerformed

	public void realizarSorteio(){

		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setFileFilter(new FileNameExtensionFilter("Text files", "txt"));

		fileChooser.setSelectedFile(new File("Sorteio_Nota_Legal_N°_"+ sorteioNumTfield.getText()+".txt"));
		fileChooser.setDialogTitle("Escolhendo o arquivo para salvar ...");
		int ret = fileChooser.showSaveDialog(jPanel2);
		if (ret != JFileChooser.APPROVE_OPTION) {
			return;
		}
		String nomeArquivo = fileChooser.getSelectedFile().getAbsolutePath();


		DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
		Date dataInicio;
		Date dataFim;
		Date dataLoteriaFederal;
		String dataInicioConversao;
		String dataFimConversao;
		String dataLoteriaFederalConversao;
		try {
			dataInicio = df.parse(dataIniSorteioTfield.getText());
			SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.S");
			dataInicioConversao = formatter.format(dataInicio);
			dataFim = df.parse(dataFimSorteioTfield.getText());
			dataLoteriaFederal = df.parse(dataLoteriaFederalTfield.getText());
			dataFimConversao = formatter.format(dataFim);
			dataLoteriaFederalConversao = formatter.format(dataLoteriaFederal);
		} catch (ParseException ex) {
			dataInicio = new Date();
			dataFim = new Date();
			dataLoteriaFederal = new Date();
			dataInicioConversao = new String();
			dataFimConversao = new String();
			dataLoteriaFederalConversao= new String();
		}

		List<Integer> numSorteado = new ArrayList<>();
		String semente = premio1Tfield.getText().replace(".", "")+ premio2Tfield.getText().replace(".", "") +
				premio3Tfield.getText().replace(".", "") + premio4Tfield.getText().replace(".", "")+ premio5Tfield.getText().replace(".", "")
				+ sorteioNumTfield.getText().replace(".", "") +dataInicioConversao+  dataFimConversao + dataLoteriaFederalConversao; 

		Random geradorRandomico = new Random();
		long sd = semente.hashCode();
		geradorRandomico.setSeed(sd); 
		Integer numTotalNotaP = Integer.parseInt(numTotalNotaParticipante.getText().replace(".", ""));
		Integer qtdPremios = Integer.parseInt(qtdPremiosTfield.getText().replace(".", ""));

		do{
			Integer numeroSorteado = geradorRandomico.nextInt(numTotalNotaP) + 1;
			if (validaNumSorteado(numeroSorteado, numSorteado)){
				numSorteado.add(numeroSorteado);
			}
		}while (numSorteado.size() < (Integer.parseInt(qtdPremiosTfield.getText().replace(".", "")) *2));

		String cabecalho = "Sorteio de Benefícios da Nota Legal Porto Alegre \r\n" +
				"__________________________________________________________\r\n\r\n" +
				"Dados do Sorteio \r\n" +
				"Versão : " + versao + "\r\n" +
				"Sorteio nº " + sorteioNumTfield.getText() + "\r\n"+
				"Data Início Período: " + dataInicioConversao + "\r\n"+
				"Data Fim Período: " + dataFimConversao + "\r\n"+
				"Número de Bilhetes gerados: " + numTotalNotaP + "\r\n"+
				"Quantidade de Prêmios distribuídos: " + qtdPremios + "\r\n\r\n"+

        		"Dados da Loteria Federal    \r\n" +
        		"Data da extração:" + dataLoteriaFederalConversao + "\r\n" +
        		"1º Premio: " + premio1Tfield.getText() + "\r\n" +
        		"2º Premio: " + premio2Tfield.getText() + "\r\n" +
        		"3º Premio: " + premio3Tfield.getText() + "\r\n" +
        		"4º Premio: " + premio4Tfield.getText() + "\r\n" +
        		"5º Premio: " + premio5Tfield.getText() + "\r\n\r\n"+
        		"__________________________________________________________\r\n" ;



		escreveResultadoEmArquivo(numSorteado, cabecalho, nomeArquivo, qtdPremios);

		JOptionPane.showMessageDialog(null, "Arquivo de Bilhetes sorteados gerado com sucesso!", "Resultado Sorteio", JOptionPane.INFORMATION_MESSAGE);
	}

	public boolean validaNumSorteado(Integer numero, List<Integer> numSorteado){
                //sorteia novamente, bilhete duplicado
                return numSorteado.stream().noneMatch((numSort) -> (numSort.equals(numero)));
	}


	public void escreveResultadoEmArquivo(List<Integer>  numSorteado, String cabecalho, String nomeArquivo, Integer qtBilhetes){

		String tipoEncoding = "UTF-8";
		OutputStreamWriter outStream = null;
		PrintWriter out = null;
		cabecalho += "\r\nBilhetes Premiados:\r\n\r\n";

		try{

			outStream = new OutputStreamWriter(new FileOutputStream(nomeArquivo), tipoEncoding);

		} catch (UnsupportedEncodingException | FileNotFoundException e2) {
			JOptionPane.showMessageDialog(null, "Problema ao gerar arquivo.", "", JOptionPane.WARNING_MESSAGE);
			return;
		}

		out = new PrintWriter(new BufferedWriter(outStream));
		out.print(cabecalho);
		int i=1;
		out.print("N° Prêmio      Número do Bilhete \r\n");
		for (Integer num : numSorteado) {
			if (i == (qtBilhetes+1)){
				out.print(" \r\n Bilhetes Suplentes:  \r\n");
				i=1;
			}
			out.print(" "+i + "                 "+ num+"\r\n");
			i++;
		}
		out.close();

	}
	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {

		try {
			for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
				if ("Nimbus".equals(info.getName())) {
					javax.swing.UIManager.setLookAndFeel(info.getClassName());

					break;
				}

			}

		} catch (ClassNotFoundException ex) {
			java.util.logging.Logger.getLogger(SorteioNotaLegal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (InstantiationException ex) {
			java.util.logging.Logger.getLogger(SorteioNotaLegal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (IllegalAccessException ex) {
			java.util.logging.Logger.getLogger(SorteioNotaLegal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		} catch (javax.swing.UnsupportedLookAndFeelException ex) {
			java.util.logging.Logger.getLogger(SorteioNotaLegal.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}
		//</editor-fold>

		/* Create and display the form */
		java.awt.EventQueue.invokeLater(() -> {
                    new SorteioNotaLegal().setVisible(true);
                });
	}

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JLabel dataFimSorteioLabel;
	private javax.swing.JFormattedTextField dataFimSorteioTfield;
	private javax.swing.JLabel dataIniSorteioLabel;
	private javax.swing.JFormattedTextField dataIniSorteioTfield;
	private javax.swing.JLabel dataLoteriaFederalLabel;
	private javax.swing.JFormattedTextField dataLoteriaFederalTfield;
	private javax.swing.JLabel devLabel;
	private javax.swing.JButton geraNumBotao;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JPanel jPanel3;
	private javax.swing.JTextField numTotalNotaParticipante;
	private javax.swing.JLabel premio1Label;
	private javax.swing.JTextField premio1Tfield;
	private javax.swing.JLabel premio2Label;
	private javax.swing.JTextField premio2Tfield;
	private javax.swing.JLabel premio3Label;
	private javax.swing.JTextField premio3Tfield;
	private javax.swing.JLabel premio4Label;
	private javax.swing.JTextField premio4Tfield;
	private javax.swing.JLabel premio5Label;
	private javax.swing.JTextField premio5Tfield;
	private javax.swing.JLabel procempaLabel;
	private javax.swing.JLabel qtdPremiosLabel;
	private javax.swing.JTextField qtdPremiosTfield;
	private javax.swing.JLabel sorteioNumLabel;
	private javax.swing.JFormattedTextField sorteioNumTfield;
	private javax.swing.JLabel totalNotaSorteioLabel;
	// End of variables declaration//GEN-END:variables

	private boolean validaCamposVazios() {

		List<String> nomesCampos = new ArrayList<>();

		if(dataLoteriaFederalTfield.getText().isEmpty()|| dataIniSorteioTfield.getText().trim().equals("/  /")){
			nomesCampos.add(dataLoteriaFederalLabel.getText());
		}
		if(premio1Tfield.getText().isEmpty() || premio1Tfield.getText().equals("00.000")){
			nomesCampos.add(premio1Label.getText());
		}
		if(premio2Tfield.getText().isEmpty() || premio1Tfield.getText().equals("00.000")){
			nomesCampos.add(premio2Label.getText());
		}
		if(premio3Tfield.getText().isEmpty() || premio1Tfield.getText().equals("00.000")){
			nomesCampos.add(premio3Label.getText());
		}
		if(premio4Tfield.getText().isEmpty() || premio1Tfield.getText().equals("00.000")){
			nomesCampos.add(premio4Label.getText());
		}
		if(premio5Tfield.getText().isEmpty() || premio1Tfield.getText().equals("00.000")){
			nomesCampos.add(premio5Label.getText());
		}

		if(sorteioNumTfield.getText().isEmpty()){
			nomesCampos.add(sorteioNumLabel.getText());
		}
		if(dataIniSorteioTfield.getText().isEmpty() || dataIniSorteioTfield.getText().trim().equals("/  /") ){
			nomesCampos.add(dataIniSorteioLabel.getText());
		}
		if(dataFimSorteioTfield.getText().isEmpty() || dataIniSorteioTfield.getText().trim().equals("/  /")){
			nomesCampos.add(dataFimSorteioLabel.getText());
		}
		if(numTotalNotaParticipante.getText().isEmpty()){
			nomesCampos.add(totalNotaSorteioLabel.getText());
		}
		if (!nomesCampos.isEmpty()){

			// create a jframe
			JFrame frame = new JFrame("");
			// show a joptionpane dialog using showMessageDialog
			JOptionPane.showMessageDialog(frame, "Por favor, preencha os campos : " + 
					nomesCampos.stream().map(i -> (i.replace(":", ""))).collect(Collectors.joining(", ")) + ".",
					"Campos obrigatórios não preenchidos.",
					JOptionPane.WARNING_MESSAGE);
			return false;
		}
		else{
			return true;
		}


	}
}
